const point = ({ macros: { Var } }) => `
    class Point {
        ${Var('x', 'Float')}
        ${Var('y', 'Float')}
    }
`;
const interpolateLin = {
    codeGenerator: ({ macros: { Var, Func } }) => `
    function interpolateLin ${Func([Var('x', 'Float'), Var('p0', 'Point'), Var('p1', 'Point')], 'Float')} {
        return p0.y + (x - p0.x) * (p1.y - p0.y) / (p1.x - p0.x)
    }
`,
    dependencies: [point],
};

export { interpolateLin, point };
