import { DspGraph } from '@webpd/compiler';
import { PdJson } from '@webpd/pd-parser';
export interface Point {
    x: number;
    y: number;
}
export interface Rectangle {
    topLeft: Point;
    bottomRight: Point;
}
export interface Control {
    type: 'control';
    patch: PdJson.Patch;
    node: PdJson.ControlNode;
}
export interface ControlContainer {
    type: 'container';
    patch: PdJson.Patch;
    node: PdJson.Node;
    children: Array<ControlTree>;
}
export type ControlTree = Control | ControlContainer;
export interface Comment {
    type: 'comment';
    patch: PdJson.Patch;
    node: PdJson.Node;
    text: string;
}
export declare const getPdNode: (pdJson: PdJson.Pd, [patchId, nodeId]: [PdJson.GlobalId, PdJson.LocalId]) => PdJson.Node;
export declare const discoverGuiControls: (pdJson: PdJson.Pd) => {
    controls: (Control | ControlContainer)[];
    comments: Comment[];
};
export declare const _discoverGuiControlsRecursive: (pdJson: PdJson.Pd, patch: PdJson.Patch, viewport?: Rectangle | null) => Array<Control | ControlContainer>;
export declare const traverseGuiControls: (controls: Array<ControlTree>, func: (control: Control) => void) => void;
export declare const collectGuiControlsInletCallerSpecs: (controls: Array<ControlTree>, graph: DspGraph.Graph) => import("@webpd/compiler/dist/types/src/compile/types").PortletsIndex;
export declare const makeTranslationTransform: (fromPoint: Point, toPoint: Point) => (fromPoint: Point) => {
    x: number;
    y: number;
};
export declare const sumPoints: (p1: Point, p2: Point) => {
    x: number;
    y: number;
};
export declare const computeRectanglesIntersection: (r1: Rectangle, r2: Rectangle) => {
    topLeft: {
        x: number;
        y: number;
    };
    bottomRight: {
        x: number;
        y: number;
    };
};
export declare const isPointInsideRectangle: (p: Point, r: Rectangle) => boolean;
