import { AudioSettings, CompilationSettings, DspGraph, NodeImplementations } from '@webpd/compiler';
import { PdJson } from '@webpd/pd-parser';
import { AbstractionLoader } from '../compile-dsp-graph/instantiate-abstractions';
import { NodeBuilders } from '../compile-dsp-graph/types';
export type WasmBuffer = ArrayBuffer;
export interface Artefacts {
    pd?: string;
    pdJson?: PdJson.Pd;
    dspGraph?: {
        graph: DspGraph.Graph;
        arrays: DspGraph.Arrays;
        pd: PdJson.Pd;
        inletCallerSpecs?: CompilationSettings['inletCallerSpecs'];
    };
    compiledJs?: string;
    compiledAsc?: string;
    wasm?: ArrayBuffer;
    wav?: Uint8Array;
    appTemplate?: {
        [filename: string]: string | ArrayBuffer;
    };
}
export interface RenderAudioSettings {
    sampleRate: number;
    blockSize: number;
    previewDurationSeconds: number;
}
export interface Settings {
    audioSettings: AudioSettings;
    renderAudioSettings: RenderAudioSettings;
    nodeBuilders: NodeBuilders;
    nodeImplementations: NodeImplementations;
    abstractionLoader: AbstractionLoader;
    inletCallerSpecs?: CompilationSettings['inletCallerSpecs'];
}
