import { NodeImplementation } from '@webpd/compiler/src/compile/types';
import { NodeBuilder } from '../../compile-dsp-graph/types';
import { TypeArgument } from '../type-arguments';
interface NodeArguments {
    typeArguments: Array<[TypeArgument, number | string]>;
    delay: number;
}
declare const stateVariables: {
    delay: number;
    scheduledMessages: number;
    outputMessages: number;
    funcScheduleMessage: number;
    funcSetDelay: number;
    funcSendMessages: number;
    funcWaitFrameCallback: number;
    funcClear: number;
};
type _NodeImplementation = NodeImplementation<NodeArguments, typeof stateVariables>;
declare const builder: NodeBuilder<NodeArguments>;
declare const nodeImplementation: _NodeImplementation;
export { builder, nodeImplementation, NodeArguments };
